module AuthGG


using HTTP, JSON


_secret = ""
_apikey = ""
_aid = ""


function init(secret:: String, apikey:: String, aid:: String)
    global _secret = secret
    global _apikey = apikey
    global _aid = aid

end


function getHWID()
    HWID = read(`cmd /c wmic csproduct get uuid`, String)
    return chop(split(String(HWID), "\n")[2], tail=4)

end


function login(username:: String, password:: String)
    try
        data = Dict(
            "type"      => "login",
            "hwid"      => getHWID(),
            "username"  => username,
            "password"  => password,
            "secret"    => _secret,
            "apikey"    => _apikey,
            "aid"       => _aid
        )

        headers = Dict(
            "User-Agent"      => "AuthGG",
            "Content-Type"    => "application/x-www-form-urlencoded"
        )

       r = HTTP.request("POST", "https://api.auth.gg/v1/", headers, body=HTTP.escapeuri(data))
       body = String(r.body)
       resp = JSON.parse(body)

       if resp["result"] == "success"
           return true, resp

       elseif resp["result"] == "invalid_details"
           return false, "Invalid Details"

       elseif resp["result"] == "invalid_hwid"
           return false, "Invalid HWID"

       elseif resp["result"] == "invalid_hwid"
           return false, "Invalid HWID"

       elseif resp["result"] == "hwid_updated"
           return false, "HWID Updated"

       elseif resp["result"] == "time_expired"
           return false, "Time Expired"

       else
           return false, "Unexpected Response"

       end

    catch
        return false, "Connection Error"

    end

end


function register(username:: String, password:: String, email:: String, license:: String)
    try
        data = Dict(
            "type"      => "register",
            "hwid"      => getHWID(),
            "username"  => username,
            "password"  => password,
            "email"     => email,
            "license"   => license,
            "secret"    => _secret,
            "apikey"    => _apikey,
            "aid"       => _aid
        )

        headers = Dict(
            "User-Agent"      => "AuthGG",
            "Content-Type"    => "application/x-www-form-urlencoded"
        )

       r = HTTP.request("POST", "https://api.auth.gg/v1/", headers, body=HTTP.escapeuri(data))
       body = String(r.body)
       resp = JSON.parse(body)
       if resp["result"] == "success"
           return true, resp

       elseif resp["result"] == "invalid_license"
           return false, "Invalid License"

       elseif resp["result"] == "invalid_hwid"
           return false, "Invalid HWID"

       elseif resp["result"] == "email_used"
           return false, "Email in Use"

       elseif resp["result"] == "invalid_username"
           return false, "Invalid/Taken Username"

       else
           return false, "Unexpected Response"

       end
    catch
        return false, "Connection Error"

    end

end

end
